/// @file XMLStruct.cpp 
/// @brief  
/// @author semmal 
/// @date 2008-12-18 

#ifndef XMLSTRUCT_H
#define XMLSTRUCT_H

#include <map>
#include <string>

#include <QtCore/QFile>

#include <QtXml/QDomDocument>

#include "Property.h"

struct MemberInfo
{
	Property<QString> type;
	Property<size_t> size;
	Property<void*> buffer;

	void set(bool value);
	void set(char value);
	void set(unsigned char value);
	void set(short value);
	void set(unsigned short value);
	void set(int value);
	void set(unsigned int value);
	void set(long value);
	void set(unsigned long value);
	void set(long long value);
	void set(unsigned long long value);
	void set(float value);
	void set(double value);
	void set(long double value);

	bool toBool();
	char toChar();
	unsigned char toUChar();
	short toShort();
	unsigned short toUShort();
	int toInt();
	unsigned int toUInt();
	long toLong();
	unsigned long toULong();
	long long toLongLong();
	unsigned long long toULongLong();
	float toFloat();
	double toDouble();
	long double toLongDouble();
};

struct StructureInfo
{
	Property<QString> name;
	std::map<QString,MemberInfo> members;
	Property<size_t> size;
	Property<void*> buffer;
};

class XMLStruct
{
public:
	XMLStruct();

	bool read(QString xml);

	Property<QDomDocument> dom;

	std::map<int, StructureInfo> structures;

	Property<size_t> size;
};

#endif // XMLSTRUCT_H
